# News #

  * 30/05/2022 Version 0.0.15 released. See the [CHANGELOG](CHANGELOG.md)
    for details.
  * 10/03/2022 Version 0.0.14 released. See the [CHANGELOG](CHANGELOG.md)
    for details.
  * 02/11/2021 Version 0.0.13 released. See the [CHANGELOG](CHANGELOG.md)
    for details.
  * 26/04/2021 Version 0.0.12 released. See the [CHANGELOG](CHANGELOG.md)
    for details.
  * 15/05/2020 Version 0.0.11 released. See the [CHANGELOG](CHANGELOG.md)
    for details.
  * 18/11/2019 Version 0.0.10 released. See the [CHANGELOG](CHANGELOG.md)
    for details.
  * 04/11/2019 Version 0.0.9 released. See the [CHANGELOG](CHANGELOG.md)
    for details.
  * 03/12/2018 Version 0.0.8 released. See the [CHANGELOG](CHANGELOG.md)
    for details.
  * 23/04/2018 Version 0.0.7 released. See the [CHANGELOG](CHANGELOG.md)
    for details.
  * 22/03/2017 Version 0.0.2 released. Documentation made available
    on [ReadTheDocs](http://fparser.readthedocs.io).
  * 16/01/2017 Parser code extracted from F2PY project to form the
    base of the fparser project.

# Introduction #

This project is based upon the Fortran (77..2003) parser originally
developed by Pearu Peterson for the F2PY project,
[www.f2py.com](http://www.f2py.com). It provides a parser for Fortran
source code implemented purely in Python.

# Obtaining #

fparser is available from the [Python Package Index](https://pypi.python.org/pypi/fparser).
It may also be cloned from [github](https://github.com/stfc/fparser). Alternatively, github provides
tarballs for each of the [releases](https://github.com/stfc/fparser/releases).

# Documentation #

The documentation for fparser is hosted on [ReadTheDocs](http://fparser.readthedocs.io).

# Code Metrics #

![fparser unit tests](https://github.com/stfc/fparser/workflows/fparser%20unit%20tests/badge.svg)
[![codecov](https://codecov.io/gh/stfc/fparser/branch/master/graph/badge.svg?token=x0abs66TST)](https://codecov.io/gh/stfc/fparser)
[![Documentation Status](https://readthedocs.org/projects/fparser/badge/?version=stable)](http://fparser.readthedocs.io/en/stable/?badge=stable)

# See also #

[www.f2py.com](http://www.f2py.com).

# News #
  * 29/09/2025 Version 0.2.1 released (bug fixes for string handling and
    loops in array constructors, support for a new, Directive node).
  * 26/11/2024 Version 0.2.0 released (support for statements behind OMP sentinels, non-standard
    STOP and bug fix for type-guard statements).
  * 31/01/2024 Version 0.1.4 released (resolves issues with WHERE statements and intrinsics).
  * 18/09/2023 Version 0.1.3 released (resolves issues with support for DO CONCURRENT).
  * 19/06/2023 Version 0.1.2 released (bug fix for handling of INCLUDE files).
  * 28/04/2023 Version 0.1.1 released (extends F2008 support with the optional
    "::" in the MODULE PROCEDURE statement).
  * 18/04/2023 Version 0.1.0 released and status changed from `alpha` to `beta`. See the [CHANGELOG](CHANGELOG.md) for more details.
  * 16/06/2022 Version 0.0.16 released. See the [CHANGELOG](CHANGELOG.md)
    for details.
  * 30/05/2022 Version 0.0.15 released. See the [CHANGELOG](CHANGELOG.md)
    for details.
  * 10/03/2022 Version 0.0.14 released. See the [CHANGELOG](CHANGELOG.md)
    for details.
  * 02/11/2021 Version 0.0.13 released. See the [CHANGELOG](CHANGELOG.md)
    for details.
  * 26/04/2021 Version 0.0.12 released. See the [CHANGELOG](CHANGELOG.md)
    for details.
  * 15/05/2020 Version 0.0.11 released. See the [CHANGELOG](CHANGELOG.md)
    for details.
  * 18/11/2019 Version 0.0.10 released. See the [CHANGELOG](CHANGELOG.md)
    for details.
  * 04/11/2019 Version 0.0.9 released. See the [CHANGELOG](CHANGELOG.md)
    for details.
  * 03/12/2018 Version 0.0.8 released. See the [CHANGELOG](CHANGELOG.md)
    for details.
  * 23/04/2018 Version 0.0.7 released. See the [CHANGELOG](CHANGELOG.md)
    for details.
  * 22/03/2017 Version 0.0.2 released. Documentation made available
    on [ReadTheDocs](http://fparser.readthedocs.io).
  * 16/01/2017 Parser code extracted from F2PY project to form the
    base of the fparser project.

# Introduction #

This project is based upon the Fortran (77..2003) parser originally
developed by Pearu Peterson for the F2PY project,
[www.f2py.com](http://www.f2py.com). It provides a parser for Fortran
source code implemented purely in Python with minimal dependencies.

# Obtaining #

fparser is available from the [Python Package Index](https://pypi.python.org/pypi/fparser).
It may also be cloned from [github](https://github.com/stfc/fparser). Alternatively, github provides
tarballs for each of the [releases](https://github.com/stfc/fparser/releases).

# Documentation #

The documentation for fparser is hosted on [ReadTheDocs](http://fparser.readthedocs.io).

# Code Metrics #

![fparser unit tests](https://github.com/stfc/fparser/workflows/fparser%20unit%20tests/badge.svg)
[![codecov](https://codecov.io/gh/stfc/fparser/branch/master/graph/badge.svg?token=x0abs66TST)](https://codecov.io/gh/stfc/fparser)
[![Documentation Status](https://readthedocs.org/projects/fparser/badge/?version=stable)](http://fparser.readthedocs.io/en/stable/?badge=stable)

![Icicle coverage plot generated by CodeCov](https://codecov.io/gh/stfc/fparser/graphs/icicle.svg?token=x0abs66TST)

# See also #

[www.f2py.com](http://www.f2py.com).

This directory contains scripts that are potentially useful for
running and/or testing fparser. The scripts and their use are described
below.

fparser2.py
-----------

Runs fparser2 on an input file and displays the de-parsed code. To see
any command line options add -h. This script can be used to choose
between parsing Fortran 2003 and Fortran 2008. An example of the use
of this script is:

> cat tmp.f90
program test
end program test
> fparser2.py tmp.f90
PROGRAM test
END PROGRAM test

fparser2_bench.py
-----------------

Generates a synthetic Fortran source benchmark in memory and then
measures the time taken by fparser2 to parse it.

parse.py
--------

Runs fparser1 on an input file and displays the parser's
representation of that code. To see any command line options add
-h. An example of the use of this script is:

> cat tmp.f90
program test
end program test
> parse.py tmp.f90
BeginSource
  blocktype='beginsource'
  name="<open file 'tmp3.f90', mode 'r' at 0x7f9bd0952f60> mode=free"
  content:
    Program
      blocktype='program'
      name='test'
      item=Line('program test',(1, 1),None,None,<reader>)
      content:
    EndProgram
      blocktype='program'
      name='test'
      item=Line('end program test',(2, 2),None,None,<reader>)

read.py
-------

Runs the fparser file reader on an input file and displays the file
reader's representation of that code. This is useful for testing that
the file reader is working as expected. Note the file reader is
required by both the fparser2.py and parse.py scripts. An example of
the use of this script is:

> cat tmp.f90
program test
end program test
> read.py tmp.f90 
line #1'program test'
line #2'end program test'

script_options.py
-----------------

Utility script used by fparser2.py, parse.py and read.py. This is
responsible for managing the common command line options in these files.

This directory contains scripts that are potentially useful for
running and/or testing fparser. The scripts and their use is described
below

fparser2.py
-----------

Runs fparser2 on an input file and displays the de-parsed code. To see
any command line options add -h. This script can be used to choose
between parsing Fortran 2003 and Fortran 2008. An example of the use
of this script is:

> cat tmp.f90
program test
end program test
> fparser2.py tmp.f90
PROGRAM test
END PROGRAM test

parse.py
--------

Runs fparser1 on an input file and displays the parser's
representation of that code. To see any command line options add
-h. An example of the use of this script is:

> cat tmp.f90
program test
end program test
> parse.py tmp.f90
BeginSource
  blocktype='beginsource'
  name="<open file 'tmp3.f90', mode 'r' at 0x7f9bd0952f60> mode=free"
  content:
    Program
      blocktype='program'
      name='test'
      item=Line('program test',(1, 1),None,None,<reader>)
      content:
    EndProgram
      blocktype='program'
      name='test'
      item=Line('end program test',(2, 2),None,None,<reader>)

read.py
-------

Runs the fparser file reader on an input file and displays the file
reader's representation of that code. This is useful for testing that
the file reader is working as expected. Note the file reader is
required by both the fparser2.py and parse.py scripts. An example of
the use of this script is:

> cat tmp.f90
program test
end program test
> read.py tmp.f90 
line #1'program test'
line #2'end program test'

script_options.py
-----------------

Utility script used by fparser2.py, parse.py and read.py. This is
responsible for managing the common command line options in these files.

# Examples
This directory contains some example scripts that are using fparser.

## fparser2_f2008.py
This is a simple Python script to show that fparser can handle separate
modules and subroutines in one file. It parses a simple Fortran
code specified as a string in the Python script, and then prints the
parsed code to stdout.

## create_dependencies.py
This program prints dependencies between Fortran source files to stdout,
in a format suitable to be used in a Makefile. Usage:

	  $ $(PATH_TO_FPARSER)/example/create_dependencies.py *f90
	  configuration_mod.o: base_mesh_config_mod.o extrusion_uniform_config_mod.o \
		  finite_element_config_mod.o io_utility_mod.o partitioning_config_mod.o \
		  perturbation_bell_config_mod.o planet_config_mod.o timestepping_config_mod.o
	  write_diagnostics_mod.o: write_methods_mod.o

It also supports files in subdirectories, e.g.:

    fparser/example$ ./create_dependencies.py  test_files/*f90
    test_files/b.o: test_files/a.o
    test_files/c.o: test_files/a.o test_files/b.o

### Known issues:
- If you do not have ``python`` in your path (e.g. you have only ``python3``
  installed), you have to either invoke the script using:

      python3 $(PATH_TO_FPARSER)/example/create_dependencies.py *.f90
  or modify the first line of the script to use ``python3`` instead of
  ``python``.
- The script will only detect dependencies from the files specified on the
  command line to files provided on the command line. It assumes that the name
  in the ``use`` statement is the same as the file name that stores the module.
  For example, if your code has:

  	  use mymodule

  then the script will look for a file with the 'root' name ``mymodule``,
  e.g. it would use ``mymodule.f90``, ``mymodule.F90``, or ``mymodule.x90``
  in the list of files provided as argument. If no matching file is found, no
  dependencies will be printed for this case, it will be silently ignored.
  You can modify the ``create_dependency.py`` script if you are using a
  different naming style for your files (see lines 120 to 123 in the script).

### Todo
- Remove the need for a file naming convention by parsing all files, and then
  using this information to find dependencies.
- Support dependencies to other libraries, e.g.:

      $ ./create_dependencies.py -l NETCDF_LIB=/opt/mynetcdf-dir my_netcdf_source.f90
      my_netcdf_source.o: $(NETCDF_LIB)
- Provide a list of modules to ignore, and abort the script if a reference
  to a module is found that is unknown (i.e. neither provided in a file name
  nor in the list of modules to ignore).

# Examples
This directory contains some example scripts that are using fparser.

## fparser2_f2008.py
This is a simple Python script to show that fparser can handle separate
modules and subroutines in one file. It parses a simple Fortran
code specified as a string in the Python script, and then prints the
parsed code to stdout.

## create_dependencies.py
This program prints dependencies between Fortran source files to stdout,
in a format suitable to be used in a Makefile. Usage:

	  $ $(PATH_TO_FPARSER)/example/create_dependencies.py *f90
	  configuration_mod.o: base_mesh_config_mod.o extrusion_uniform_config_mod.o \
		  finite_element_config_mod.o io_utility_mod.o partitioning_config_mod.o \
		  perturbation_bell_config_mod.o planet_config_mod.o timestepping_config_mod.o
	  write_diagnostics_mod.o: write_methods_mod.o

It also supports files in subdirectories, e.g.:

    fparser/example$ ./create_dependencies.py  test_files/*f90
    test_files/b.o: test_files/a.o
    test_files/c.o: test_files/a.o test_files/b.o

### Known issues:
- If you do not have ``python`` in your path (e.g. you have only ``python3``
  installed), you have to either invoke the script using:

      python3 $(PATH_TO_FPARSER)/example/create_dependencies.py *.f90
  or modify the first line of the script to use ``python3`` instead of
  ``python``.
- The script will only detect dependencies from the files specified on the
  command line to files provided on the command line. It assumes that the name
  in the ``use`` statement is the same as the file name that stores the module.
  For example, if your code has:

  	  use mymodule

  then the script will look for a file with the 'root' name ``mymodule``,
  e.g. it would use ``mymodule.f90``, ``mymodule.F90``, or ``mymodule.x90``
  in the list of files provided as argument. If no matching file is found, no
  dependencies will be printed for this case, it will be silently ignored.
  You can modify the ``create_dependency.py`` script if you are using a
  different naming style for your files (see lines 120 to 123 in the script).

### Todo
- Remove the need for a file naming convention by parsing all files, and then
  using this information to find dependencies.
- Support dependencies to other libraries, e.g.:

      $ ./create_dependencies.py -l NETCDF_LIB=/opt/mynetcdf-dir my_netcdf_source.f90
      my_netcdf_source.o: $(NETCDF_LIB)
- Provide a list of modules to ignore, and abort the script if a reference
  to a module is found that is unknown (i.e. neither provided in a file name
  nor in the list of modules to ignore).

## split_file.py
This script splits one Fortran source file into several files, each containing
one top level module, subroutine, function or program. Each file uses the name
of the program unit (module-, subroutine-, function-, program name). The
extension will be ``.F90`` if there are preprocessor directives in the file,
and ``.f90`` otherwise.

Additionally, ``split_file.py`` will create a Makefile to build either the
binary (if a program is found in the file), or all object files. If any of
the environment variables ``F90``, ``F90FLAGS``, and ``LDFLAGS`` are set at
run time of the script, it will use these values as default values in the
makefile. But by setting these environment variables when running ``make``,
these defaults can always be overwritten. The Makefile also has a ``clean``
target, which will remove all ``.mod``, object, and the program file (if
available). It uses the ``create_dependencies.py`` script to add the
required dependencies to the Makefile.

MODULE a_mod

  ! Access_Stmt private will be removed:

  ! Attr_Spec with 0 and 1 additional attribute, the protected will be remobed
  REAL :: planet_radius = 123
  REAL, PARAMETER :: planet_radius_constant = 123

  LOGICAL :: public_protected = .FALSE.
  LOGICAL :: only_protected = .FALSE.
  LOGICAL :: private_protected = .FALSE.

  ! Access_stmt with public, this will be unmodified
  PUBLIC :: public_protected
  ! Protected_Stmt - the whole statement will be removed
  ! Access_stmt with private - the whole statement will be removed

  TYPE :: my_type
    ! Private_Components_Stmt in a type will be removed
    INTEGER :: a, b
    CONTAINS
    ! This private will also be removed.

  END TYPE my_type

  ! Access_Spec - the `private` will be removed
  TYPE(my_type), PUBLIC :: my_var

  CONTAINS
  SUBROUTINE sub_a
  END SUBROUTINE sub_a
END MODULE a_mod

! -----------------------------------------------------------------------------
! BSD 3-Clause License
!
! Copyright (c) 2019, Science and Technology Facilities Council
! All rights reserved.
!
! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:
!
! * Redistributions of source code must retain the above copyright notice, this
!   list of conditions and the following disclaimer.
!
! * Redistributions in binary form must reproduce the above copyright notice,
!   this list of conditions and the following disclaimer in the documentation
!   and/or other materials provided with the distribution.
!
! * Neither the name of the copyright holder nor the names of its
!   contributors may be used to endorse or promote products derived from
!   this software without specific prior written permission.
!
! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
! "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
! LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
! FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
! COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
! INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
! BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
! LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
! LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
! ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
! POSSIBILITY OF SUCH DAMAGE.
! -----------------------------------------------------------------------------
! Author R. W. Ford STFC Daresbury Lab
program bad_char
! Ê
end program bad_char

! Modified work Copyright (c) 2017 Science and Technology Facilities Council
! Original work Copyright (c) 1999-2008 Pearu Peterson

! All rights reserved.

! Modifications made as part of the fparser project are distributed
! under the following license:

! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are
! met:

! 1. Redistributions of source code must retain the above copyright
! notice, this list of conditions and the following disclaimer.

! 2. Redistributions in binary form must reproduce the above copyright
! notice, this list of conditions and the following disclaimer in the
! documentation and/or other materials provided with the distribution.

! 3. Neither the name of the copyright holder nor the names of its
! contributors may be used to endorse or promote products derived from
! this software without specific prior written permission.

! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
! "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
! LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
! A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
! HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
! SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
! LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
! DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
! THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
! (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
! OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

! --------------------------------------------------------------------

! The original software (in the f2py project) was distributed under
! the following license:

! Redistribution and use in source and binary forms, with or without
! modification, are permitted provided that the following conditions are met:

!   a. Redistributions of source code must retain the above copyright notice,
!      this list of conditions and the following disclaimer.
!   b. Redistributions in binary form must reproduce the above copyright
!      notice, this list of conditions and the following disclaimer in the
!      documentation and/or other materials provided with the distribution.
!   c. Neither the name of the F2PY project nor the names of its
!      contributors may be used to endorse or promote products derived from
!      this software without specific prior written permission.

! THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
! AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
! IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
! ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR
! ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
! DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
! SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
! CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
! LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
! OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
! DAMAGE.

      program foo
      use testmod
      implicit none

      print *, i

      end program foo

MODULE mod1
  INTEGER :: a
  CONTAINS
  SUBROUTINE p(args)
    IMPLICIT NONE
    REAL :: args

  END SUBROUTINE p
END MODULE mod1

SUBROUTINE sub
END SUBROUTINE sub

REAL FUNCTION func(args)
  USE mod1
  func = 1
END FUNCTION func

PROGRAM test_prog
  USE mod1
END PROGRAM test_prog

module a_mod

   ! Access_Stmt private will be removed:
   private

   ! Attr_Spec with 0 and 1 additional attribute, the protected will be remobed
   REAL, protected  :: planet_radius = 123
   REAL, parameter, protected  :: planet_radius_constant = 123

   LOGICAL :: public_protected = .FALSE.
   LOGICAL :: only_protected = .FALSE.
   LOGICAL :: private_protected = .FALSE.

   ! Access_stmt with public, this will be unmodified
   PUBLIC  :: public_protected
   ! Protected_Stmt - the whole statement will be removed
   PROTECTED :: public_protected, only_protected
   ! Access_stmt with private - the whole statement will be removed
   private :: private_protected

   type :: my_type
      ! Private_Components_Stmt in a type will be removed
      private
      integer :: a, b
   contains
      ! This private will also be removed.
      private

   end type my_type

   ! Access_Spec - the `private` will be removed
   type(my_type), private :: my_var

contains
   subroutine sub_a
   end subroutine sub_a
end module a_mod
